import random
import time

import scrapy
import json


class figureSpider(scrapy.Spider):
    name = "tk_fig"
    start_urls = []

    def __init__(self):
        url_filename = "result_url.json"
        with open(url_filename, "rb") as f:
            urls = json.load(f)
            for url in urls:
                self.start_urls.append((url["hero"], "https://zh.wikipedia.org" + url["url"][0]))

    def start_requests(self):
        for name, url in self.start_urls:
            yield scrapy.Request(url=url, callback=self.parse)

    def parse(self, response, **kwargs):
        result = {"姓名": response.css("h1::text").get(),
                  "简介": self.concat(response.css("div>p")[0].css("*:not(style)::text").getall(), "")}

        for item in response.css(".infobox.vcard").css("tr"):
            if len(item.css("th")) == 1 and len(item.css("td")) == 1:
                name = item.css("th *::text").get()
                if name == "null" or name=="简化字" or name =="繁体字": continue
                result[name] = self.concat(item.css("td *::text").getall(), "")

        yield result

    def concat(self, list, result):
        for i in list:
            result += i
        return result
